#ifndef WIDGET_H_
#define WIDGET_H_

#include <glib-object.h>
#include <goocanvas.h>

#include "xml.h"
#include "widget.h"
#include "tag.h"

#define WPS_TYPE_WIDGET			(wps_widget_get_type())
#define WPS_WIDGET(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), WPS_TYPE_WIDGET, WPSWidget))
#define WPS_WIDGET_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), WPS_TYPE_WIDGET, WPSWidget))
#define WPS_IS_WIDGET(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), WPS_TYPE_WIDGET))
#define WPS_IS_WIDGET_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), WPS_TYPE_WIDGET))
#define WPS_WIDGET_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), WPS_TYPE_WIDGET, WPSWidget))

typedef struct _WPSWidgetPrivate	WPSWidgetPrivate;


struct _WPSWidget
{
	GObject			parent_instance;
	GObject			*object;
	GooCanvasItem		*goo_item;
	WidgetInfo		*widget_info;
	GList			*link_attributes;
	gchar			*name;
	gchar			*type_name;
	WPSWidgetPrivate 	*priv;
};

typedef struct _WPSWidget       WPSWidget;

struct _WPSWidgetClass
{
	GObjectClass parent_class;
	void	(*update_prop)(WPSWidget *widget);
	
};

typedef enum {
	DIR_IN,
	DIR_OUT
} attr_direction;


struct _LinkAttribute {
	gchar *tag;
	gchar *name;
	GValue *value;
	attr_direction direction;
	Tag *connected_tag;
};


typedef struct _WPSWidgetClass  WPSWidgetClass;
typedef struct _LinkAttribute	LinkAttribute;

GType		wps_widget_get_type();
void wps_widget_create_gvalue(LinkAttributeInfo *link_attr_info, GValue *value);

//GList	*wps_widget_create_from_info(WPSPage *page, GList *widget_info_list);
#endif /*WIDGET_H_*/
